package vishnu.testvis.visual;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.List;
import java.applet.*;
import javax.swing.*;

/** A panel that is added to the frame containing an on screen list of keywords to select
*   and deselect
*   @author Athina Economou
*/
public class KeywordPanel extends JPanel
{
    /** the base frame */
    protected RadVizPanel f;
    protected KeyWordArray keyWordArray;
    protected int wordCount;
    protected Vector  selArrayIndex;
    protected Vector  listArrayIndex;
    protected List available;
    protected List selected;
    protected int largeFont = 16;
    protected int smallFont = 14;


    /** Constructor
    * @param drawing canvas
    * @param base frame
    */
    public KeywordPanel(final CvManyPoints canvas1, RadVizPanel f)
    {
        this.f = f;

        keyWordArray = canvas1.getKeyWords();
        wordCount = keyWordArray.getNumWords();
        selArrayIndex = new Vector();
        listArrayIndex = new Vector();
        available = new List(12, false);
        selected = new List(12, false);
        // mc
        SymAction lSymAction = new SymAction();

//        Panel base = new Panel();
        setLayout(new BorderLayout(10,0));
        //setSize(50,400);
        JPanel labels = new JPanel();
        Font font1 = new Font("Monospaced", Font.PLAIN, largeFont);
        labels.setFont(font1);
        labels.setForeground(Color.black);
        labels.add(new Label("Available           Displayed"));

        JPanel rightPanel = new JPanel();
        Font font = new Font("Dialog", Font.PLAIN, smallFont);
        rightPanel.setFont(font);
        JPanel leftPanel = new JPanel();
        leftPanel.setFont(font);

        for (int c=0; c< wordCount;c++)
            if (keyWordArray.getState(c))
            {
                selected.add(keyWordArray.getWord(c));
                selArrayIndex.addElement(new Integer(c));
            }
            else
            {
                available.add(keyWordArray.getWord(c));
                listArrayIndex.addElement(new Integer(c));
            }
        available.addActionListener(lSymAction);
        available.addItemListener(new ItemListener()
            {
                public void itemStateChanged(ItemEvent event)
                {
                    if(event==null) return;
                    try
                    {
                        int index =((List)event.getItemSelectable()).getSelectedIndex();
                        if(index >= 0)
                        {
                            String keywords = ((List)event.getItemSelectable()).getSelectedItem();
                            Integer result = (Integer)listArrayIndex.elementAt(index);
                            selected.add(keywords);
                            selArrayIndex.addElement(result);

                            available.remove(keywords);
                            listArrayIndex.removeElementAt(index);

                            for (int c=0; c<keyWordArray.getNumWords(); c++)
                                keyWordArray.setState(c,false);

                            for (int c=0;c<(int)selArrayIndex.size();c++)
                            {
                                Integer result1 = (Integer)selArrayIndex.elementAt(c);
                                int index1 = result1.intValue();
                             keyWordArray.setState(index1,true);
                            } // for
                            canvas1.recalc();
                        } // if
                    } //try
                    catch (ArrayIndexOutOfBoundsException e)
                    {
                    } // catch
                } //itemstate changed
            }); // ItemListener
            //mc
            selected.addActionListener(lSymAction);
            selected.addItemListener(new ItemListener()
            {
                public void itemStateChanged(ItemEvent event)
                {
                    //System.out.println("calling getSeleced index");
                    try
                    {
                        int index =((List)event.getItemSelectable()).getSelectedIndex();
                    //System.out.println("Index");
                    //System.out.println(index);
                        if(index >= 0)
                        {
                            String keywords = ((List)event.getItemSelectable()).getSelectedItem();
                            Integer result = (Integer)selArrayIndex.elementAt(index);

                            available.add(keywords);
                            listArrayIndex.addElement(result);

                            selected.remove(keywords);
                            selArrayIndex.removeElementAt(index);

                            for (int c=0; c<keyWordArray.getNumWords(); c++)
                                keyWordArray.setState(c,false);

                            for (int c=0;c<(int)selArrayIndex.size();c++)
                            {
                                Integer result1 = (Integer)selArrayIndex.elementAt(c);
                                int index1 = result1.intValue();
                                keyWordArray.setState(index1,true);
                            } // for
                            canvas1.recalc();
                        } // if
                    } // try
                    catch (ArrayIndexOutOfBoundsException e)
                    {
                    }
                }
            });

            leftPanel.add(available);
            rightPanel.add(selected);
            add(labels, "North");
            add(rightPanel, "East");
            add(leftPanel, "West");
            //base.add(text, "South");
            setVisible(true);

    }
    public void update()
    {
        keyWordArray = f.canvas1.getKeyWords();
        wordCount = keyWordArray.getNumWords();
        selected.removeAll();
        available.removeAll();
        selArrayIndex.removeAllElements();
        listArrayIndex.removeAllElements();
        for (int c=0; c< wordCount;c++)
            if (keyWordArray.getState(c))
            {
                selected.add(keyWordArray.getWord(c));
                selArrayIndex.addElement(new Integer(c));
            }
            else
            {
                available.add(keyWordArray.getWord(c));
                listArrayIndex.addElement(new Integer(c));
            }
    }


    /** A dummy action listener to absorb double mouse clicks */
    class SymAction implements java.awt.event.ActionListener
    {
        public void actionPerformed(java.awt.event.ActionEvent event)
        {
            Object object = event.getSource();
            //System.out.println("Action event");
        }
    }
}
